function load()
{
//	document.ontouchmove = function(e){ e.preventDefault(); };
}

var messageQueue = new Array();
var loading = false;
var id = null;
var service = null;
var meta = null;


/* Link Language */ 
function loadPage(pageID)
{
	var commandParameters = new Object();
	commandParameters.pageID = pageID;
	
	sendJSONMessage("loadPage", commandParameters, "loggingCallback");	
}

function loadPopup(pageID, backgroundColor, backgroundImage, backgroundImageHeight, yPos)
{
	var commandParameters = new Object();
	commandParameters.pageID = pageID;
	commandParameters.backgroundColor = backgroundColor;
	commandParameters.backgroundImage = backgroundImage;
	commandParameters.backgroundImageHeight = backgroundImageHeight;
	commandParameters.backgroundImageYPos = yPos;
	
	sendJSONMessage("loadPopup", commandParameters, "loggingCallback");	
}

function closePopup()
{
	var commandParameters = new Object();	
	sendJSONMessage("close", commandParameters, "loggingCallback");
}

function logMessage(message)
{
	var commandParameters = new Object();	
	commandParameters.log = message;
	
	sendJSONMessage("log", commandParameters, "loggingCallback");
}

function loggingCallback(e)
{
	alert('Callback Made\n' + e.returnValue);
}


function loadExternalURL(URL)
{
	var commandParameters = new Object();	
	commandParameters.link = URL;
	
	sendJSONMessage("loadExternalURL", commandParameters, "loggingCallback");
}

function loadMinibrowserWithURL(URL)
{

	var commandParameters = new Object();	
	commandParameters.link = URL;
	
	sendJSONMessage("loadMinibrowserWithURL", commandParameters, "loggingCallback");
}

// Begin Fantasy football link language

// Function loginSucess
// URL - feed URL for the main menu 
function loginSuccess(URL)
{
	var commandParameters = new Object();
	commandParameters.URL = URL;		
	sendJSONMessage("loginSuccess", commandParameters, "loggingCallback");
}

// my Teams
// Parameters:
// action - action identifier one of ["move"|"claim"|"add"|"trade"|"drop"]
// URL - feed URL for the action sheet
function performTeamManagementAction(action, URL)
{	
	var commandParameters = new Object();	
	commandParameters.action = action;
	commandParameters.URL = URL;	
	sendJSONMessage("performTeamManagementAction", commandParameters, "loggingCallback");
}

// my Teams
// Parameters:
// message - the message describing the action
// details - a array of details for the message each element is an object with 2 member variables, 'player' and 'action'
// URL - feed URL for the action sheet
function showTransactionMessageOverlay(message,details)
{
	var commandParameters = new Object();	
	commandParameters.MESSAGE = message;
	commandParameters.DETAILS = details;	
	sendJSONMessage("showTransactionMessageOverlay", commandParameters, "loggingCallback");
}

// All players and My Teams  

// Function loadScreen 
// Parameters:
// screenName - one of ["playerCard"|"fantasyCast"|"teamClubhouse"]
// URL - feed URL for drop player modal views
function loadScreen(screenName, URL)
{
	var commandParameters = new Object();	
	commandParameters.screenName = screenName; 
	commandParameters.URL = URL;
	sendJSONMessage("loadScreen", commandParameters, "loggingCallback");
}

// End  Fantasy football link language



/* 
 JSON Message Builder
 Expects:
 Command Name (String)
 Parameters (Object)
 Callback (String))
 */
function sendJSONMessage(inCommandName, inParameters, inCallback)
{	
	JSONMessage = new Object();

	JSONMessage.commandName = inCommandName;
	JSONMessage.params = inParameters;
	JSONMessage.callBack = inCallback;
	
	var JSONString = JSON.stringify(JSONMessage);
	loading = true;
	
	pushMessageToQueue(JSONString);
}

function pushMessageToQueue(JSONString)
{
	messageQueue.push(JSONString);
	if(messageQueue.length == 1) // Shortcut the queue
	{ 
		window.location = messageQueue[0];
	}
}

function popQueue()
{
	messageQueue.shift(); // get rid of the command that just executed
	
	if(loading == true)
	{
		if(messageQueue.length > 0)
		{
			message = messageQueue.shift();
			if(message == "")
				alert("empty message");
			else
				window.location = message;
		}
		else
		{
			loading = false;
		}
	}
}

// RealTime Feed
function startRealTimeFeed(feedUrl, callback, statusCallback) {
	var commandParameters = new Object();	
	commandParameters.feedUrl = feedUrl;
	commandParameters.messageCallback = callback;
	commandParameters.statusCallback = statusCallback;
	sendJSONMessage("beginRealTime", commandParameters, statusCallback);
}

function stopRealTimeFeed(statusCallback) {
	sendJSONMessage("endRealTime", null, statusCallback);
}

function loadSettingsView() {	
	sendJSONMessage("loadSettingsView",null,null);
}

// pass a dictionary like this:
//     {
//       "pageName":"scorecenter/index",
//       "hier1":"main",
//       "prop35":"mlb~nba~ncb"
//     }
function omnitureTrack(paramsDictionary){
	sendJSONMessage("omnitureTrack",paramsDictionary,null);
}


// omniture tracking
function omnitureHit() {
	
	try {
		if (service)
		{
			omnitureDict = new Object();
			omnitureDict.hier1 = service.replace("extra/", "").replace("general/", "");
			if (id)
			{
				omnitureDict.pageName = "game";
				omnitureDict.prop35 = "id="+id;
				if (meta) {
					omnitureDict.prop35 += ":" + meta;
				}
			} else {
				omnitureDict.pageName = "scores";				
			}
			omnitureTrack(omnitureDict);
		}
	} catch (e) {}
}

// Visibility Callbacks
function webViewFinishedLoading() { // Called when the final render is complete
	initializeLinks();
	scrollToToday();
}

// qa or prod? would be cool to get this from bootstrap
var host = "m.espn.go.com";

function viewWillDisappear() {
	if (typeof(clearTap) == "function") clearTap();
	if (typeof(stopAjax) == "function") stopAjax();
	if (typeof(stopRTS) == "function") stopRTS();
	return window.pageYOffset;
}

function viewDidAppear(savedYOffset) {
	if (typeof(startAjax) == "function") startAjax();
	if (typeof(startRTS) == "function") startRTS();
	omnitureHit();
	if(typeof(savedYOffset) == "number")
	{
		window.scrollTo(0, savedYOffset);
	}
}
